#+TITLE: Heap Insert operation
#+AUTHOR: VLEAD
#+DATE: [2018-06-12 Tue]
#+SETUPFILE: ../org-templates/level-1.org
#+TAGS: boilerplate(b)
#+EXCLUDE_TAGS: boilerplate
#+OPTIONS: ^:nil

* Introduction
- This document contains js for heap insert operation.
- Contains an API for implementations of heapsort extract max operation.
- Div elements of html are appended to the body using javascript
  append child tag. 
- This is the org file for heap insert operation which will
  be tangled as heapInsert.js

* Global Variables
- Global variables are variables declared in the begining of a program and their scope is throughout the program.
- They can be used and accessed from anywhere within the code.
- We have used certain global variables in our code to visualise a heap like x and y coordinates global arrays etc.
- The canvas used to display the sorted array have also been declared global in out code so that they can be called from any function later on.

#+NAME: part-1
#+BEGIN_SRC js

'use strict';

var stepDelay = 2000;
var arrayStartx = 150;
var arrayStarty = 100;
var canvas;
var ind = 0;
var ctx;
var in_insert;
var is_insert = 0;
var is_flag = 0;
var interv;
var nos = []
var done = {};
var toColor = -122121;

#+END_SRC

* Function to display numbers 
- Function to display the numbers.
- Initiates the canvas for displaying the text.
- The HTML <canvas> element is used to draw graphics, on the fly, via JavaScript.
  The <canvas> element is only a container for graphics.Javascript
  is used to actually draw the graphics.
  Canvas has several methods for drawing paths, boxes,
  circles, text, and adding images.
- Heap is generated by the numbers that are randomly generated.
- The canvas displays to the user the instructons.
- Here we have made sure that only unique numbers into the heap.

#+NAME: part-2
#+BEGIN_SRC js
function displayNos() {
  ind = 0;
  nos = [];
  toColor = -122121;
  var canvas = document.getElementById("canv");
  while (canvas.firstChild) {
      canvas.removeChild(canvas.firstChild);
  }
  var i = 0;
  while(i<6) {
    var numRand = Math.floor(Math.random() * 101);
    var flagNum = 0;
    for(var j = 0; j < nos.length; j++) {
      if(numRand == nos[j])
        flagNum = 1;
    }
    if(flagNum == 0) {
      nos.push(numRand);
      i++;
    }
  }
  var qn="Let us see how these elements are inserted into the heap : -9, "
  qn=qn+nos[0]+','+' '+nos[1]+','+' '+nos[2]+','+' '+nos[3]+','+' '+nos[4]+','+' '+nos[5];
  var node = document.createTextNode(qn);
  canvas.style.color = "red"
  canvas.style.font = "Arial"
  canvas.style.fontSize = "20px"
  canvas.appendChild(node);
}

#+END_SRC

* Function for API implementation
- The maker function takes the html div element as parameter and returns the DOM.
- In this function the buttons used is created and appended using document.appendchild.
- The class and ID of certain elements are set here.
- Event listeners are added here which decide which function
  to invoke on click.
- There are are several buttons which have their classes set
  here to add styling in the style sheet.
- There is one input box for user input.
- There exists a single buttons for visualizing heap insert operation.

#+NAME: part-3
#+BEGIN_SRC js
var hsMaker = function() {
  var obj = {};
  var heapsortInsert = function(divElem) {
    var dd = document.createElement("div");
    var ins = document.createElement("div");
    var br2 = document.createElement("BR");
    var br = document.createElement("BR");
    var btn = document.createElement("button");
    var playSpan = document.createElement("span");
    var pauseSpan = document.createElement("span");
    var info = document.createElement("span");
    playSpan.className = "glyphicon glyphicon-play play-button-span"
    pauseSpan.className = "glyphicon glyphicon-pause play-button-span"
    info.className = "glyphicon glyphicon-info-sign info-span"
    btn.className = 'play-button';
    ins.className = "instruction"
    var ins_bar = document.createElement("div");
    ins_bar.className = "instruction_bar"
    ins_bar.appendChild(info)
    var instruction_text = document.createElement("div")
    instruction_text.className = "instruction_text"
    var para = document.createElement("p")
    var node = document.createTextNode("Instructions :")
    para.appendChild(node)
    instruction_text.append(para)
    para = document.createElement("p")
    node = document.createTextNode("Click on Play Button to see the demonstration")
    para.appendChild(node)
    instruction_text.append(para)
    para = document.createElement("p")
    node = document.createTextNode("Pause Button pause the animation at that time")
    para.appendChild(node)
    instruction_text.append(para)
    ins.appendChild(ins_bar)
    ins.appendChild(instruction_text)

    var btn2 = document.createElement("button");
    btn2.className = 'pause-button';
    btn2.value ="Pause"

    
    var mycanv = document.createElement("div");
    mycanv.id='canv';

    dd.appendChild(btn);
    dd.appendChild(playSpan)
    dd.appendChild(btn2)
    dd.appendChild(pauseSpan)
        
    var dd3=document.createElement("div");
    dd3.id = "d3svg";
    divElem.appendChild(mycanv);
    divElem.appendChild(ins)
    divElem.appendChild(br2);
    divElem.appendChild(dd3);
    divElem.appendChild(dd);

    playSpan.addEventListener("click",function(event){
      playSpan.className = "glyphicon glyphicon-repeat repeat-button-span"
      if(btn2.value=="Play" && is_insert==1)
      {
        btn2.value="Pause";
        pauseSpan.className = "glyphicon glyphicon-pause play-button-span"
        is_flag=0;
        heapsortInterval();
      }
      ind=0;
      btn2.value="Pause"
      heap.storage=[];
      restoreInitial();
      is_insert=0;
      is_flag=0;
      done={};
      clearInterval(interv);
      displayNos();
      if(nos.length>1)
        heap.insert(-9);
      event.preventDefault();
    });

    pauseSpan.addEventListener("click",function(event){
      if(btn2.value=="Pause")
      { 
        is_flag=1;
        btn2.value="Play";
        pauseSpan.className = "glyphicon glyphicon-play play-button-span"
        clearInterval(interv);
      }
      else if(btn2.value=="Play" && is_insert==1)
      {
        is_flag=0;
        pauseSpan.className = "glyphicon glyphicon-pause play-button-span"
        btn2.value="Pause";
        heapsortInterval();
      }
      event.preventDefault();
    });        
  };
  obj.heapsortInsert = heapsortInsert;
  return obj;

};

#+END_SRC

* Function to initialise heap
- Function used to initialise a new heap.
- Uses this.storage and sets it to null.
#+NAME: part-4
#+BEGIN_SRC js

var Heap = function() {
	this.storage = [];
};

#+END_SRC

* Reahipify operation
- Used to reheapify the heap.
- toColor variable tells us the value of the node which needs to be coloured.
- This ensures that heap property is satisfied at every step.

#+NAME: part-5
#+BEGIN_SRC js

var reheapify = function() {
  if(is_flag==1)
  {
    clearInterval(interv);
    return;
  }
  var parentInd = Math.ceil(in_insert/2-1);
  if (parentInd < 0 || heap.storage[in_insert] <= heap.storage[parentInd]) {
    is_insert=0;
    clearInterval(interv);
    if(ind<nos.length)
    {
      if(is_flag!=1 && done[ind]!=1)
      {
        heap.insert(nos[ind]);
        done[ind]=1;
        ind=ind+1;
      }
    }
    else
    {
      var ii = document.getElementById("play-pause-button");
      ii.innerText = "Done";
    }
    return 'value added to index '+in_insert;
  }
  
  toColor =  heap.storage[in_insert]; 

  heap.storage[in_insert] = heap.storage[in_insert] ^ heap.storage[parentInd];
  heap.storage[parentInd] = heap.storage[in_insert] ^ heap.storage[parentInd];
  heap.storage[in_insert] = heap.storage[in_insert] ^ heap.storage[parentInd];


  swapNodes(in_insert, parentInd);
  in_insert=parentInd;
};

#+END_SRC

* Heap sort interval
- Function used to call reheapify function.
- This function is used to call the reheapify function after stepDelay
  interval
- After stepDelay seconds the color of the nodes are changed to white.
#+NAME: part-6
#+BEGIN_SRC js

var heapsortInterval = function() {
	if(is_flag!=1)
	{
		interv = setInterval(reheapify,stepDelay);
		svg.selectAll('circle').style("fill", "white");
	}
}
#+END_SRC

* Heap prototype insert function
- It is used to insert the elements into the heap.
- It calls the heapsortInterval which calls the reheapify function
#+NAME: part-7
#+BEGIN_SRC js

Heap.prototype.insert = function(value) {
	is_insert=1;

	var vl=String(value);
	this.storage.push(value);
	insertNode(value);
	var that = this;

	setTimeout(function() {
		in_insert=that.storage.length-1;
		clearInterval(interv);
		heapsortInterval();
	}, stepDelay);


};
#+END_SRC

* Building an instance of heap
#+NAME: part-8
#+BEGIN_SRC js
var heap = new Heap();
#+END_SRC

* Tangle
#+BEGIN_SRC javascript :tangle js/heapInsert.js :eval no :noweb yes
<<part-1>>
<<part-2>>
<<part-3>>
<<part-4>>
<<part-5>>
<<part-6>>
<<part-7>>
<<part-8>>
#+END_SRC
